; Set up environment.
#NoEnv
#SingleInstance, Off
SetBatchLines, -1
SetControlDelay, -1
DetectHiddenWindows, On
SetWorkingDir, %A_ScriptDir%

; Build main GUI.
GoSub, Gui_Build_Main

Return ; End of auto-execute section.


Gui_Build_Main:
{
    ; Build GUI.
    Gui, Margin, 3, 5
    Gui, Add, Text    , xm     ym    w70  h20 Right 0x200                        , Source folder:
    Gui, Add, Edit    , xm+75  ym    w205 h20                vSource_edt         , 
    Gui, Add, Button  , xm+285 ym    w30  h20                vSource_btn  gBrowse, ...
    Gui, Add, GroupBox, xm+5   ym+20 w240 h35 Section                            ,
    Gui, Add, Radio   , xs+5   ys+10 w120 h20 Checked        vFolders_rdo        , Parse folders only
    Gui, Add, Radio   , xs+130 ys+10 w105 h20                vFiles_rdo          , Parse files only
    Gui, Add, Button  , xm+250 ym+25 w65  h30                vGo_btn gGo         , &Go
    Gui, Add, Statusbar
        SB_SetText( "Ready.", 1 )
    GUI_ID := WinExist()
    Gui, Show, AutoSize Center, Path Parser
}
Return ; End of auto-execute section.


GuiEscape:
GuiClose:
{
    ExitApp
}
Return


Browse:
{
    Gui, 1: Submit, NoHide
    Source_Folder := ""
    FileSelectFolder, Source_Folder, , 2, Select source folder.
    If ( ErrorLevel != 1 )
    {
        GuiControl, Text, Source_edt, % Source_Folder
    }
    ; Right justify the edit control's content if longer than the control's length
    SendMessage, 0xB1, 500, 500, Edit1 ; 0xB1 is EM_SETSEL
}
Return


Go:
{
    Gui, Submit, NoHide
    ; Do some pre-checks.
    If ( Source_edt = "" OR ! FileExist( Source_edt ) )
    {
        MsgBox, 48, Error, Please choose a valid source folder.
        Return
    }

    If ( Folders_rdo = 1 ) ? Parse_Type := 2 : Parse_Type := 0 ; Determine folders or files.
    Sleep, 50
    
    Loop, % Source_edt . "\*", % Parse_Type, 1 ; Recurse into subfolders.
    {
        SB_SetText( "Processing: " . A_LoopFileName, 1 )
        ; Check to see if path exceeds 127 chars.  If so, build out separate text block.
        If ( StrLen( A_LoopFileFullPath ) > 127 )
        {
            Block_Long .= A_LoopFileFullPath . "`n"
        }
        
        ; Change all backslashes in the path to a greater than sign.
        StringReplace, myPath, A_LoopFileFullPath, \, <, All
        ; Change any underscores in the final filename or foldername to spaces.
        StringReplace, myFilename, A_LoopFileName, _, %A_Space%, All

        If ( Parse_Type = 0 ) ; If in files mode, strip the file extension.
        {
            SplitPath, myFilename, , , , myEndFilename,
        }
        Else ; Otherwise, leave as is.
        {
            myEndFilename := myFilename
        }
        ; Build out the modified data.
        Block .= myPath . "\" . myEndFilename . "`n"
    }
    SB_SetText( "Done.", 1 )
    
    FileSelectFile, myFile, S16, , Save file,
    If ( ErrorLevel != 1 )
    {
        SplitPath, myFile, OutFileName, OutDir, OutExtension, OutNameNoExt, OutDrive
        
        FileDelete, % myFile
        FileDelete, % OutDir . "\" . OutNameNoExt . "_long." . OutExtension
        
        ; Write both blocks of text out to files.
        FileAppend, % Block     , % myFile
        FileAppend, % Block_Long, % OutDir . "\" . OutNameNoExt . "_long." . OutExtension
    }
    Block      := ""
    Block_Long := ""
}
Return
